 nolist
 include "ti83plus.inc"
 globals on
;This is the application header definition area required for all apps.
 ;Field: Program length
	DB 080h,0Fh
;Length=0 (N/A for unsigned apps)
	DB 00h,00h,00h,00h 
;Field: Program type
	DB 080h,012h
	DB 01h,04h
;Field: App ID
	DB 080h,021h
;Id = 1
	DB 01h
;Field: App Build
	DB 080h,031h
	;Build = 1
	DB 01h
;Field: App Name
	DB 080h,048h
;App Name = APPNAME
	DB "Encrypt"
	db "o"
;	db "0"-11
;Field: App Pages
	DB 080h,081h
;App Pages = 1
	DB 01h
;No default splash screen
	DB 080h,090h
;Field: Date stamp - 5/12/1999
	DB 003h,026h,009h,004h,004h,06fh,01bh,080h
;Dummy encrypted TI date stamp signature
	DB 002h ,00dh ,040h                             
	DB 0a1h ,06bh ,099h ,0f6h ,059h ,0bch ,067h 
	DB 0f5h ,085h ,09ch ,009h ,06ch ,00fh ,0b4h ,003h ,09bh ,0c9h 
	DB 003h ,032h ,02ch ,0e0h ,003h ,020h ,0e3h ,02ch ,0f4h ,02dh 
	DB 073h ,0b4h ,027h ,0c4h ,0a0h ,072h ,054h ,0b9h ,0eah ,07ch 
	DB 03bh ,0aah ,016h ,0f6h ,077h ,083h ,07ah ,0eeh ,01ah ,0d4h 
	DB 042h ,04ch ,06bh ,08bh ,013h ,01fh ,0bbh ,093h ,08bh ,0fch 
	DB 019h ,01ch ,03ch ,0ech ,04dh ,0e5h ,075h 
;Field: Program Image length
	DB 80h,7Fh
	DB 0,0,0,0    ;Length=0, N/A
	DB 0,0,0,0    ;Reserved
	DB 0,0,0,0    ;Reserved
	DB 0,0,0,0    ;Reserved
	DB 0,0,0,0	;Reserved
 list

VPutS macro   pencol,penrow,str
	call VPutSMacro
	DB	pencol
	DB	penrow
	DB str,0
	.endm

VPutSI macro   pencol,penrow,str
	call VPutSIMacro
	DB	pencol
	DB	penrow
	DB str,0
	.endm

VPutSScreen macro   pencol,penrow,str
	call VPutSScreenMacro
	DB	pencol
	DB	penrow
	DB str,0
	.endm

PutS macro   curcol,currow,str
	call PutSMacro
	DB	curcol
	DB	currow
	DB str,0
	.endm

currentdisplay		equ appbackupscreen
currentselected	equ appbackupscreen+1
menuselected1		equ appbackupscreen+2
menuselected2		equ appbackupscreen+3
quitSP				equ appbackupscreen+4 ; 2bytes
savevals				equ appbackupscreen+6 ;6bytes
getkeyhooksave		equ appbackupscreen+12 ;4bytes
interruptcounter	equ appbackupscreen+16 ;1byte
selfmodifyingcode	equ appbackupscreen+32
saferam				equ appbackupscreen+64
interrupttable		equ appbackupscreen+142

fastforward		equ 0 ;asm_Flag1
;asm_Flag2
fastforwardicon	equ 0
continueicon		equ 1
inverted				equ 2
noicon				equ 3

StartApp:
    ld      hl,AppVectors
    b_call  AppInit          ; install monitor vectors to catch putaways
;
    b_call RunIndicOff
;
;   I set an error handler so that if somehow the system displays an error
;   I can block the 'GOTO' option from being given.
;
;   quitSP is some ram location defined by the app writer 2 bytes
;
;   If you do this then when you exit your app from a 'QUIT' option
;   the stack level must be what it is at immediately following
;   the 'AppOnErr' macro below:
;
    AppOnErr  NoGoTo
    ld      (quitSP),sp      ; save sp so can do appofferr safely
	 call setTofull
	res indicOnly, (IY + indicFlags)
	set textWrite, (IY + sGrFlags) ;write to grbuf
	res plotLoc, (IY + plotFlags)
	set apdAble,(IY+apdFlags) ; turn on APD
	set apdRunning,(IY+apdFlags) ; turn on APD
	res fastforwardicon,(IY+asm_Flag2)
	res continueicon,(IY+asm_Flag2)
	res inverted,(IY+asm_Flag2)
	set noicon,(IY+asm_Flag2)
	di ;install interrupt
	ld	hl,interrupttable		;start of interrupt table
	ld	de,interrupttable+1		;start of interrupt table +1
	ld	bc,256			;257 - 1 bytes to copy
	ld	(hl),9Ah		;load $9a into (hl)
	ldir				;ld (hl) into (de), inc hl and de, ld (hl) 
	;now you have a 257 byte table starting at $9900 filled with $9a
	ld	hl,interrupt_start			;\
	ld	de,9A9Ah				; | copy interrupt routine to $9a9a
	ld	bc,interrupt_end-interrupt_start	; |
	ldir						;/
	ld hl,9A9Ah+interrupt_replace-interrupt_start+1
	in a,(6)
	ld (hl),a
	ld	a,99h
	ld	i,a			;load $99 into I
	im	2			;switch to mode 2
	ei				;enable interrupts
loadfromappvar:
	ld hl,appvarname
	rst 20h
	B_CALL ChkFindSym
	jr c,loaddefaults
	ld a,b
	or a
	jr z,safecontinue
	ld hl,appvarname
	rst 20h
	B_CALL Arc_Unarc
	jr loadfromappvar
safecontinue:
	ld hl,appvarcheckbytes
	ld b,6
checkbytesloop:
	ld a,(de)
	cp (hl)
	jr nz,loaddefaults
	inc de
	inc hl
	djnz checkbytesloop
	ex de,hl
	call LdHLInd
	jr load
loaddefaults:
	ld hl,0FFh*256+0
load:
	ld (menuselected1),hl
	inc h
	jr nz,menu2
menu:
	set noicon,(IY+asm_Flag2)
	ld a,0FFh
	ld (menuselected2),a
	B_CALL GrBufClr
	ld hl,exitstr
	ld a,0
	call Displaykey15
	ld hl,chapterstr
	ld e,11
	call VPutSmultiple
	ld hl,9*256+4
	ld b,2
	ld c,"1"
	ld a,(menuselected1)
	call menu_loopstart
	call VPutSscreen
 db "Encrypto chapters",0
 db 0
 db 0FFh
menu_keyloop:
	B_CALL GetKey
	cp kUp
	jr z,menu1_up
	cp kDown
	jr z,menu1_down
	cp kQuit
	jr z,QUITApp_savemenu
	cp kClear
	jr z,QUITApp_savemenu
	cp kYequ
	jr z,QUITApp_savemenu
	cp kEnter
	jr z,menu_enter
	cp k1
	jr c,menu_keyloop
	cp k9
	jr nc,menu_keyloop
	jr menu_gotonr

menu_gotonr:
	sub k1
	cp 2
	jr nc,menu_keyloop
	ld (menuselected1),a
	jr menu_enter

menu_loopstart:
	push hl
	push af
menu_loop:
	ld (pencol),hl
	ld a,c
	B_CALL VPutMap
	inc c
	ld a,":"
	B_CALL VPutMap
	ld a,h
	add 7
	ld h,a
	djnz menu_loop
	set textInverse, (IY + textFlags)
	pop af
	ld b,a
	inc b
	add "1"
	ld c,a
	pop hl
	ld a,h
	sub 7
menu_multloop:
	add 7
	djnz menu_multloop
	ld h,a
	dec l
	ld (pencol),hl
	ld a," "
	B_CALL VPutMap
	ld a,c
	B_CALL VPutMap
	ld a,":"
	B_CALL VPutMap
	res textInverse, (IY + textFlags)
	ret

menu1_up:
	ld hl,menuselected1
	call menu_up
	jr menu
menu_up:
	ld a,(hl)
	or a
	ret z
	dec a
	ld (hl),a
	ret
menu1_down:
	ld hl,menuselected1
	ld b,1
	call menu_down
	jr menu
menu_down:
	ld a,(hl)
	cp b
	ret z
	inc a
	ld (hl),a
	ret

menu2_up:
	ld hl,menuselected2
	call menu_up
	jr menu2
menu2_down:
	ld hl,menuselected2
	dec b
	call menu_down
	jr menu2


menu_enter:
	xor a
	ld (menuselected2),a
menu2:
	set noicon,(IY+asm_Flag2)
	B_CALL GrBufClr
	ld bc,20*256+94
	ld hl,8*256+1
	call Drawrect
	ld hl,exitstr
	ld a,0
	call Displaykey15
	ld hl,upstr
	ld a,38
	call Displaykey15
	ld a,(menuselected1)
	ld hl,11*256+4
	ld (pencol),hl
	push af
	add "1"
	B_CALL VPutMap
	ld a,":"
	B_CALL VPutMap
	pop af
	ld hl,subsectionstrs
	add a
	ld e,a
	ld d,0
	add hl,de
	call LdHLInd
	ld b,(hl)
	push bc
	inc hl
	call VPutS
	dec hl
	ld e,14
	call VPutSmultiple
	pop bc
	push bc
	ld hl,23*256+7
	ld c,"1"
	ld a,(menuselected2)
	call menu_loopstart
	call VPutSscreen
 db "Encrypto sections",0
 db 0
 db 0FFh
 	pop bc
menu2_keyloop:
	push bc
	B_CALL GetKey
	pop bc
	cp kUp
	jr z,menu2_up
	cp kDown
	jr z,menu2_down
	cp kQuit
	jr z,QUITApp_savemenu
	cp kClear
	jr z,QUITApp_savemenu
	cp kEnter
	jr z,menu2_enter
	cp kYequ
	jr z,QUITApp_savemenu
	cp kZoom
	jr z,menu
	cp k1
	jr c,menu2_keyloop
	cp k9
	jr nc,menu2_keyloop
	jr menu2_gotonr

menu2_gotonr:
	sub k1
	cp b
	jr nc,menu2
	ld (menuselected2),a
	jr menu2_enter

menu2_enter:
	ld de,(menuselected1)
	ld a,e
	add a
	ld c,a
	ld b,0
	ld hl,subsectionnrs
	add hl,bc
	call LdHLInd
	ld c,d
	add hl,bc
	ld a,(hl)
	res noicon,(IY+asm_Flag2)
changedisplay:
	res inverted,(IY+asm_Flag2)
	ld (currentdisplay),a
	push af
	call findmenu
	ld l,0
	ld a,b
	cp 4
	jr c,changedisplay_noinc
	inc l
	sub 3
changedisplay_noinc:
	dec a
	ld h,a
	ld (menuselected1),hl
	pop af
	add a
	ld d,0
	ld e,a
	ld hl,displaytable
	add hl,de
	call LdHLInd
	push hl
	B_CALL GrBufClr
	pop hl
	call indirectcall
keyloop:
	B_CALL GetKey ;temporarily to allow screenshots
	call readkeys
	jr keyloop

findmenu:
	ld hl,subsection1nr
	ld b,0
findmenu_loop:
	cp (hl)
	ret c
	inc hl
	inc b
	jr findmenu_loop

readkeys:
	pop hl ;to make the jumps legal
	im 2
	cp kLeft
	jr z,key_left
	cp kRight
	jr z,key_right
	cp kQuit
	jr z,menu2
	cp kClear
	jr z,menu2
	push hl
	ret

smallreadkeys:
	pop hl ;to make the jumps legal
	cp kQuit
	jr z,menu2
	cp kClear
	jr z,menu2
	push hl
	ret

key_left:
	ld a,(currentdisplay)
	or a
	jr z,keyloop
	dec a
	jr changedisplay
key_right:
	ld a,(currentdisplay)
	cp nrofpages-1
	jr z,keyloop
	inc a
	jr changedisplay

chapterstr:
	db "SUBSTITUTION",0
	db "OTHER TYPES",0
	db 0FFh
subsectionstrs:
	dw subsection1str
	dw subsection2str
subsection1str:
	db 3
	db "SUBSTITUTION",0,0
	db "CEASAR",0
	db "MONOALPHABETIC",0
	db "JEFFERSON WHEEL",0
	DB 0FFh
subsection2str:
	db 2
	db "OTHER TYPES",0,0
	db "RAIL FENCE",0
	db "XOR",0
	DB 0FFh

subsectionnrs:
	dw subsection1nr
	dw subsection2nr

subsection1nr:
	db 0,7,14
subsection2nr:
	db 20,28
	db 99 ;voor menu locatie update
upstr:
	db "    UP",0
exitstr:
	db "EXIT",0

displaytable:
	dw ceasar1
	dw ceasar2
	dw ceasar2_ani
	dw ceasar3
	dw ceasar4
	dw ceasar4_ani
	dw ceasar5
	dw monoalpha1
	dw monoalpha2
	dw monoalpha2_ani
	dw monoalpha3
	dw monoalpha4
	dw monoalpha5
	dw monoalpha7
	dw jefferson1
	dw jefferson2
	dw jefferson3
	dw jefferson3_ani
	dw jefferson4
	dw jefferson5
	dw railfence1
	dw railfence2
	dw railfence2_ani
	dw railfence3
	dw railfence4
	dw railfence5
	dw railfence5_ani
	dw railfence6
	dw xor1
	dw xor2
	dw xor3
	dw xor4
	dw xor4_ani
	dw xor5
	dw xor6
	dw xor6_ani
	dw xor7
	dw xor8
	dw xor8_ani
	dw xor9
	dw xor10
	dw the_end
displaytable_end:
nrofpages equ (displaytable_end-displaytable)/2


	
	include "ceasar.asm"
	include "monoalpha.asm"
	include "jefferson.asm"
	include "railfence.asm"
	include "xor.asm"
	include "helper functions.asm"

the_end:
	pop hl
	call VPutSscreen
 db "Encrypto - The end",0
 db "This is the end of this app.",0
 db "If you want to learn more",0
 db "about encryption you can",0
 db "ask your math teacher,",0
 db "read books or search the",0
 db "internet.",0
 db 0FFh
the_end_keyloop:
	B_CALL GetKey
	cp kRight
	jr z,loaddefaults
	call readkeys
	jr the_end_keyloop

appvarcheckbytes:
	dw 6
	db "Enc",42h
appvarname:
	db appvarobj,"Encrypto"

endofapp:
